Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class CalendarValue

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.AtomicValue
              net.sf.saxon.value.CalendarValue

All Implemented Interfaces:
  java.lang.Comparable, Expression, Item, java.io.Serializable, ValueRepresentation

Direct Known Subclasses:
  DateTimeValue, DateValue, TimeValue

public abstract class CalendarValue
extends AtomicValue
implements java.lang.Comparable

Abstract superclass for Date, Time, and DateTime.

See Also:
  Serialized Form

Field Summary
`static int` | `NO_TIMEZONE`

Fields inherited from class net.sf.saxon.value.Value
`EMPTY_CLASS_ARRAY`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`CalendarValue()`

Method Summary
`abstract CalendarValue` | `add(DurationValue duration)` Add a duration to this date/time value
`abstract CalendarValue` | `adjustTimezone(int tz)` Return a new date, time, or dateTime with the same normalized value, but in a different timezone
`void` | `appendTimezone(FastStringBuffer sb)` Add a string representation of the timezone, typically formatted as "Z" or "+03:00" or "-10:00", to a supplied string buffer
`static void` | `appendTimezone(int tz, FastStringBuffer sb)`
`abstract int` | `compareTo(CalendarValue other, XPathContext context)` Compare this value to another value of the same type, using the supplied ConversionContext to get the implicit timezone if required.
`abstract CalendarValue` | `copy()` Make a copy of this date, time, or dateTime value
`abstract java.util.GregorianCalendar` | `getCalendar()` Get a Java Calendar object that represents this date/time value.
`java.lang.String` | `getStringValue()` Convert the value to a string
`int` | `getTimezoneInMinutes()` Get the timezone value held in this object.
`boolean` | `hasTimezone()` Determine whether this value includes a timezone
`CalendarValue` | `removeTimezone()` Return a date, time, or dateTime with the same localized value, but without the timezone component
`void` | `setTimezoneInMinutes(int minutes)` Modify the timezone value held in this object.
`SecondsDurationValue` | `subtract(CalendarValue other, XPathContext context)` Determine the difference between two points in time, as a duration
`abstract DateTimeValue` | `toDateTime()` Convert the value to a DateTime, retaining all the components that are actually present, and substituting conventional values for components that are missing

Methods inherited from class net.sf.saxon.value.AtomicValue
`checkPermittedContents, convert, convert, convertPrimitive, display, effectiveBooleanValue, evaluateAsString, evaluateItem, getCardinality, getComponent, getImplementationMethod, getLength, getPrimitiveValue, getStringValueCS, getTypedValue, hasBuiltInType, iterate, process, schemaEquals, toString`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asIterator, asValue, collapseWhitespace, convert, convertJavaObjectToXPath, convertToJava, equals, getDependencies, getItemType, getIterator, getParentExpression, getSpecialProperties, hashCode, itemAt, iterateSubExpressions, makeQNameValue, normalizeWhitespace, optimize, promote, reduce, simplify, stringToNumber, trimWhitespace, typeCheck`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.lang.Comparable
`compareTo`

Field Detail

### NO_TIMEZONE

    public static final int NO_TIMEZONE

See Also:
  Constant Field Values

Constructor Detail

### CalendarValue

    public CalendarValue()

Method Detail

### hasTimezone

    public final boolean hasTimezone()

  Determine whether this value includes a timezone

  Returns:
    true if there is a timezone in the value, false if not

### setTimezoneInMinutes

    public final void setTimezoneInMinutes(int minutes)

  Modify the timezone value held in this object. This must be done only while the value is being constructed.

  Parameters:
    `minutes` - The timezone offset from GMT in minutes, positive or negative; or the special value NO_TIMEZONE indicating that the value is not in a timezone (this is the default if this method is not called)

### toDateTime

    public abstract DateTimeValue toDateTime()

  Convert the value to a DateTime, retaining all the components that are actually present, and substituting conventional values for components that are missing

### getTimezoneInMinutes

    public final int getTimezoneInMinutes()

  Get the timezone value held in this object.

  Returns:
    The timezone offset from GMT in minutes, positive or negative; or the special value NO_TIMEZONE indicating that the value is not in a timezone

### getStringValue

    public final java.lang.String getStringValue()

  Convert the value to a string

  Specified by:
    `getStringValue` in interface `Item`
  Specified by:
    `getStringValue` in class `AtomicValue`

### getCalendar

    public abstract java.util.GregorianCalendar getCalendar()

  Get a Java Calendar object that represents this date/time value. The Calendar object will be newly created for the purpose

  Returns:
    A Calendar object representing the date and time. Note that Java can only represent the time to millisecond precision, and that it does not support the full range of timezones required by XPath (-14:00 to +14:00)

### add

    public abstract CalendarValue add(DurationValue duration)
                               throws XPathException

  Add a duration to this date/time value

  Parameters:
    `duration` - the duration to be added (which might be negative)
  Returns:
    a new date/time value representing the result of adding the duration. The original object is not modified.
  Throws:
    `XPathException`

### subtract

    public SecondsDurationValue subtract(CalendarValue other,
                                         XPathContext context)
                                  throws XPathException

  Determine the difference between two points in time, as a duration

  Parameters:
    `other` - the other point in time
    `context` - the dynamic context, used to obtain timezone information. May be set to null only if both values contain an explicit timezone, or if neither does so.
  Returns:
    the duration as an xdt:dayTimeDuration
  Throws:
    `XPathException` - for example if one value is a date and the other is a time

### removeTimezone

    public final CalendarValue removeTimezone()

  Return a date, time, or dateTime with the same localized value, but without the timezone component

  Returns:
    the result of removing the timezone

### adjustTimezone

    public abstract CalendarValue adjustTimezone(int tz)

  Return a new date, time, or dateTime with the same normalized value, but in a different timezone

  Parameters:
    `tz` - the new timezone, in minutes
  Returns:
    the date/time in the new timezone

### copy

    public abstract CalendarValue copy()

  Make a copy of this date, time, or dateTime value

### compareTo

    public abstract int compareTo(CalendarValue other,
                                  XPathContext context)

  Compare this value to another value of the same type, using the supplied ConversionContext to get the implicit timezone if required.

### appendTimezone

    public final void appendTimezone(FastStringBuffer sb)

  Add a string representation of the timezone, typically formatted as "Z" or "+03:00" or "-10:00", to a supplied string buffer

  Parameters:
    `sb` - The StringBuffer that will be updated with the resulting string representation

### appendTimezone

    public static final void appendTimezone(int tz,
                                            FastStringBuffer sb)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD